package gFace;
//-------------------------------------------------------------------------------
//
// MainFaceG.java                                       Ulrich Mller    22.02.09
//                                                      Aspire Eclipse 3.4 Java 6
// Testprogramm fr das Package ftcomputing.robo.*,  Swing Anwendung
// ROBO Interface mit Motor an M3, Endtaster an I5, Impulstaster an I6
//                             M4,              I7,                 I8
//                Taster an I1, Photowiderstand an AX, Ultraschall an D1
//                Lampen an O1, O2, O3 und O4
//
// -------------------------------------------------------------------------------

import java.awt.*;
import javax.swing.*;
import ftcomputing.robo.*;

public class MainFaceG {
	JFrame frmMain    = new JFrame("Hello FishFace");
	JLabel lblStatus  = new JLabel("Kontrolle Interface", JLabel.CENTER);
	JLabel lblUltra   = new JLabel(" ", JLabel.CENTER);
	JLabel lblWider   = new JLabel(" ", JLabel.CENTER);
	JLabel lblHinweis = new JLabel(" ", JLabel.CENTER);
	FishFace ft = new FishFace();
	int iHandle;

	public MainFaceG() {
		frmMain.setLayout(new GridLayout(0, 1, 12, 24));
		frmMain.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frmMain.setSize(300, 200);
		lblStatus.setForeground(Color.BLUE);
		frmMain.add(lblStatus);
		frmMain.add(lblUltra);
		frmMain.add(lblWider);
		frmMain.add(lblHinweis);
		frmMain.setVisible(true);
	}

	public static void main(String[] args) {
		MainFaceG mf = new MainFaceG();
		mf.Action();
	}

	private void Action() {
		try {
			ft.openInterface(IFTypen.ftROBO_first_USB, 0, Distance.UltraSonic);
			lblStatus.setText("RobMotors Home : I5 und I7 drcken");
			MoveHome();
			lblStatus.setText("RobMotors : 20 Impulse nach rechts");
			MoveRight(20);
			lblStatus.setText("Blinking : I1 drcken");
			ft.waitForInput(Inp.I1);
			lblHinweis.setText("Ende : ESC-Taste oder I1");
			int Runde = 0;
			do {
				lblStatus.setText("Runde : " + ++Runde);
				Blinken(333);
			} while ((ft.jrGetInput(iHandle, 1) == 0)
					&& (JavaFish.escape() == 0));
		} catch (FishFaceException eft) {
			lblStatus.setText(eft.toString());
		} finally {
			ft.closeInterface();
			lblHinweis.setText("Finito : X-Drcken");
		}
	}

	private void Blinken(int Dauer) {
		lblUltra.setText("Entfernung : " + ft.getDistance(Inp.D1));
		lblWider.setText("Helligkeit : " + ft.getAnalog(Inp.AX));
		ft.setLamp(Out.O1, Dir.On);
		ft.pause(Dauer);
		ft.setLamp(Out.O2, Dir.On);
		ft.pause(Dauer);
		ft.setLamp(Out.O3, Dir.On);
		ft.pause(Dauer);
		ft.setLamp(Out.O4, Dir.On);
		ft.pause(Dauer * 2);
		ft.setMotors(0);
		ft.pause(Dauer);
	}
	
	private void MoveHome() {
		ft.setMotor(Mot.M3, Dir.Left, Speed.Full, 999);
		ft.setMotor(Mot.M4, Dir.Left, Speed.Full, 999);
		ft.waitForMotors(0, Mot.M3, Mot.M4);
		ft.setCounter(Inp.I5, 0);
		ft.setCounter(Inp.I7, 0);
	}
	private void MoveRight(int Impulse) {
		ft.setMotor(Mot.M3, Dir.Right, Speed.Full, Impulse);
		ft.setMotor(Mot.M4, Dir.Right, Speed.Half, Impulse);
		ft.waitForMotors(0, Mot.M3, Mot.M4);
	}
}
